diff --git a/lib/source_impl.cc b/lib/source_impl.cc
index a28f314..a8d5534 100644
--- a/lib/source_impl.cc
+++ b/lib/source_impl.cc
@@ -117,11 +117,14 @@ source_impl::source_impl( const std::string &args )
   : gr::hier_block2 ("source_impl",
         gr::io_signature::make(0, 0, 0),
         args_to_io_signature(args)),
-    _sample_rate(NAN)
+    _manager(make_dev_manager(to_hier_block2()))
 {
   size_t channel = 0;
   bool device_specified = false;
 
+  message_port_register_hier_in( osmosdr::CMD_PORT );
+  msg_connect( self(), osmosdr::CMD_PORT, _manager, osmosdr::CMD_PORT );
+
   std::vector< std::string > arg_list = args_to_vector(args);
 
   std::vector< std::string > dev_types;
@@ -383,32 +386,10 @@ source_impl::source_impl( const std::string &args )
     }
 #endif
 
-    if ( iface != NULL && long(block.get()) != 0 ) {
-      _devs.push_back( iface );
-
-      for (size_t i = 0; i < iface->get_num_channels(); i++) {
-#ifdef HAVE_IQBALANCE
-        gr::iqbalance::optimize_c::sptr iq_opt = gr::iqbalance::optimize_c::make( 0 );
-        gr::iqbalance::fix_cc::sptr     iq_fix = gr::iqbalance::fix_cc::make();
-
-        connect(block, i, iq_fix, 0);
-        connect(iq_fix, 0, self(), channel++);
-
-        connect(block, i, iq_opt, 0);
-        msg_connect(iq_opt, "iqbal_corr", iq_fix, "iqbal_corr");
-
-        _iq_opt.push_back( iq_opt.get() );
-        _iq_fix.push_back( iq_fix.get() );
-#else
-        connect(block, i, self(), channel++);
-#endif
-      }
-    } else if ( (iface != NULL) || (long(block.get()) != 0) )
-      throw std::runtime_error("Either iface or block are NULL.");
-
+    _manager->add_device( block, iface );
   }
 
-  if (!_devs.size())
+  if (!_manager->get_num_mboards())
     throw std::runtime_error("No devices specified via device arguments.");
 #ifdef WORKAROUND_GR_HIER_BLOCK2_BUG
   } catch ( std::exception &ex ) {
@@ -443,545 +424,220 @@ source_impl::source_impl( const std::string &args )
 
 size_t source_impl::get_num_channels()
 {
-  size_t channels = 0;
-
-  BOOST_FOREACH( source_iface *dev, _devs )
-    channels += dev->get_num_channels();
-
-  return channels;
+  return _manager->get_num_channels();
 }
 
 bool source_impl::seek( long seek_point, int whence, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->seek( seek_point, whence, dev_chan );
-
-  return false;
+  return _manager->seek( seek_point, whence, chan );
 }
 
-#define NO_DEVICES_MSG  "FATAL: No device(s) available to work with."
-
 osmosdr::meta_range_t source_impl::get_sample_rates()
 {
-  if ( ! _devs.empty() )
-    return _devs[0]->get_sample_rates(); // assume same devices used in the group
-#if 0
-  else
-    throw std::runtime_error(NO_DEVICES_MSG);
-#endif
-  return osmosdr::meta_range_t();;
+  return _manager->get_sample_rates();
 }
 
-double source_impl::set_sample_rate(double rate)
+double source_impl::set_sample_rate( double rate )
 {
-  double sample_rate = 0;
-
-  if (_sample_rate != rate) {
-#if 0
-    if (_devs.empty())
-      throw std::runtime_error(NO_DEVICES_MSG);
-#endif
-    BOOST_FOREACH( source_iface *dev, _devs )
-      sample_rate = dev->set_sample_rate(rate);
-
-#ifdef HAVE_IQBALANCE
-    size_t channel = 0;
-    BOOST_FOREACH( source_iface *dev, _devs ) {
-      for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++) {
-        if ( channel < _iq_opt.size() ) {
-          gr::iqbalance::optimize_c *opt = _iq_opt[channel];
-
-          if ( opt->period() > 0 ) { /* optimize is enabled */
-            opt->set_period( dev->get_sample_rate() / 5 );
-            opt->reset();
-          }
-        }
-
-        channel++;
-      }
-    }
-#endif
-
-    _sample_rate = sample_rate;
-  }
-
-  return sample_rate;
+  return _manager->set_sample_rate(rate);
 }
 
 double source_impl::get_sample_rate()
 {
-  double sample_rate = 0;
-
-  if (!_devs.empty())
-    sample_rate = _devs[0]->get_sample_rate(); // assume same devices used in the group
-#if 0
-  else
-    throw std::runtime_error(NO_DEVICES_MSG);
-#endif
-  return sample_rate;
+  return _manager->get_sample_rate();
 }
 
 osmosdr::freq_range_t source_impl::get_freq_range( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_freq_range( dev_chan );
-
-  return osmosdr::freq_range_t();
+  return _manager->get_freq_range( chan );
 }
 
 double source_impl::set_center_freq( double freq, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _center_freq[ chan ] != freq ) {
-          _center_freq[ chan ] = freq;
-          return dev->set_center_freq( freq, dev_chan );
-        } else { return _center_freq[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_center_freq( freq, chan );
 }
 
 double source_impl::get_center_freq( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_center_freq( dev_chan );
-
-  return 0;
+  return _manager->get_center_freq( chan );
 }
 
 double source_impl::set_freq_corr( double ppm, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _freq_corr[ chan ] != ppm ) {
-          _freq_corr[ chan ] = ppm;
-          return dev->set_freq_corr( ppm, dev_chan );
-        } else { return _freq_corr[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_freq_corr( ppm, chan );
 }
 
 double source_impl::get_freq_corr( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_freq_corr( dev_chan );
-
-  return 0;
+  return _manager->get_freq_corr( chan );
 }
 
 std::vector<std::string> source_impl::get_gain_names( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain_names( dev_chan );
-
-  return std::vector< std::string >();
+  return _manager->get_gain_names( chan );
 }
 
 osmosdr::gain_range_t source_impl::get_gain_range( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain_range( dev_chan );
-
-  return osmosdr::gain_range_t();
+  return _manager->get_gain_range( chan );
 }
 
 osmosdr::gain_range_t source_impl::get_gain_range( const std::string & name, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain_range( name, dev_chan );
-
-  return osmosdr::gain_range_t();
+  return _manager->get_gain_range( name, chan );
 }
 
 bool source_impl::set_gain_mode( bool automatic, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _gain_mode[ chan ] != automatic ) {
-          _gain_mode[ chan ] = automatic;
-          bool mode = dev->set_gain_mode( automatic, dev_chan );
-          if (!automatic) // reapply gain value when switched to manual mode
-            dev->set_gain( _gain[ chan ], dev_chan );
-          return mode;
-        } else { return _gain_mode[ chan ]; }
-      }
-
-  return false;
+  return _manager->set_gain_mode( automatic, chan );
 }
 
 bool source_impl::get_gain_mode( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain_mode( dev_chan );
-
-  return false;
+  return _manager->get_gain_mode( chan );
 }
 
 double source_impl::set_gain( double gain, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _gain[ chan ] != gain ) {
-          _gain[ chan ] = gain;
-          return dev->set_gain( gain, dev_chan );
-        } else { return _gain[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_gain( gain, chan );
 }
 
 double source_impl::set_gain( double gain, const std::string & name, size_t chan)
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->set_gain( gain, name, dev_chan );
-
-  return 0;
+  return _manager->set_gain( gain, name, chan );
 }
 
 double source_impl::get_gain( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain( dev_chan );
-
-  return 0;
+  return _manager->get_gain( chan );
 }
 
 double source_impl::get_gain( const std::string & name, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain( name, dev_chan );
-
-  return 0;
+  return _manager->get_gain( name, chan );
 }
 
 double source_impl::set_if_gain( double gain, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _if_gain[ chan ] != gain ) {
-          _if_gain[ chan ] = gain;
-          return dev->set_if_gain( gain, dev_chan );
-        } else { return _if_gain[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_if_gain( gain, chan );
 }
 
 double source_impl::set_bb_gain( double gain, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _bb_gain[ chan ] != gain ) {
-          _bb_gain[ chan ] = gain;
-          return dev->set_bb_gain( gain, dev_chan );
-        } else { return _bb_gain[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_bb_gain( gain, chan );
 }
 
 std::vector< std::string > source_impl::get_antennas( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_antennas( dev_chan );
-
-  return std::vector< std::string >();
+  return _manager->get_antennas( chan );
 }
 
 std::string source_impl::set_antenna( const std::string & antenna, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _antenna[ chan ] != antenna ) {
-          _antenna[ chan ] = antenna;
-          return dev->set_antenna( antenna, dev_chan );
-        } else { return _antenna[ chan ]; }
-      }
-
-  return "";
+  return _manager->set_antenna( antenna, chan );
 }
 
 std::string source_impl::get_antenna( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_antenna( dev_chan );
-
-  return "";
+  return _manager->get_antenna( chan );
 }
 
 void source_impl::set_dc_offset_mode( int mode, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        dev->set_dc_offset_mode( mode, dev_chan );
+  _manager->set_dc_offset_mode( mode, chan );
 }
 
 void source_impl::set_dc_offset( const std::complex<double> &offset, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        dev->set_dc_offset( offset, dev_chan );
+  _manager->set_dc_offset( offset, chan );
 }
 
 void source_impl::set_iq_balance_mode( int mode, size_t chan )
 {
-  size_t channel = 0;
-#ifdef HAVE_IQBALANCE
-  BOOST_FOREACH( source_iface *dev, _devs ) {
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++) {
-      if ( chan == channel++ ) {
-        if ( chan < _iq_opt.size() && chan < _iq_fix.size() ) {
-          gr::iqbalance::optimize_c *opt = _iq_opt[chan];
-          gr::iqbalance::fix_cc *fix = _iq_fix[chan];
-
-          if ( IQBalanceOff == mode  ) {
-            opt->set_period( 0 );
-            /* store current values in order to be able to restore them later */
-            _vals[ chan ] = std::pair< float, float >( fix->mag(), fix->phase() );
-            fix->set_mag( 0.0f );
-            fix->set_phase( 0.0f );
-          } else if ( IQBalanceManual == mode ) {
-            if ( opt->period() == 0 ) { /* transition from Off to Manual */
-              /* restore previous values */
-              std::pair< float, float > val = _vals[ chan ];
-              fix->set_mag( val.first );
-              fix->set_phase( val.second );
-            }
-            opt->set_period( 0 );
-          } else if ( IQBalanceAutomatic == mode ) {
-            opt->set_period( dev->get_sample_rate() / 5 );
-            opt->reset();
-          }
-        }
-      }
-    }
-  }
-#else
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->set_iq_balance_mode( mode, dev_chan );
-#endif
+  _manager->set_iq_balance_mode( mode, chan );
 }
 
 void source_impl::set_iq_balance( const std::complex<double> &balance, size_t chan )
 {
-  size_t channel = 0;
-#ifdef HAVE_IQBALANCE
-  BOOST_FOREACH( source_iface *dev, _devs ) {
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++) {
-      if ( chan == channel++ ) {
-        if ( chan < _iq_opt.size() && chan < _iq_fix.size() ) {
-          gr::iqbalance::optimize_c *opt = _iq_opt[chan];
-          gr::iqbalance::fix_cc *fix = _iq_fix[chan];
-
-          if ( opt->period() == 0 ) { /* automatic optimization desabled */
-            fix->set_mag( balance.real() );
-            fix->set_phase( balance.imag() );
-          }
-        }
-      }
-    }
-  }
-#else
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->set_iq_balance( balance, dev_chan );
-#endif
+  _manager->set_iq_balance( balance, chan );
 }
 
 double source_impl::set_bandwidth( double bandwidth, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _bandwidth[ chan ] != bandwidth || 0.0f == bandwidth ) {
-          _bandwidth[ chan ] = bandwidth;
-          return dev->set_bandwidth( bandwidth, dev_chan );
-        } else { return _bandwidth[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_bandwidth( bandwidth, chan );
 }
 
 double source_impl::get_bandwidth( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_bandwidth( dev_chan );
-
-  return 0;
+  return _manager->get_bandwidth( chan );
 }
 
 osmosdr::freq_range_t source_impl::get_bandwidth_range( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( source_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_bandwidth_range( dev_chan );
-
-  return osmosdr::freq_range_t();
+  return _manager->get_bandwidth_range( chan );
 }
 
 void source_impl::set_time_source(const std::string &source, const size_t mboard)
 {
-  if (mboard != osmosdr::ALL_MBOARDS){
-      _devs.at(mboard)->set_time_source( source );
-      return;
-  }
-
-  for (size_t m = 0; m < _devs.size(); m++){ /* propagate ALL_MBOARDS */
-      _devs.at(m)->set_time_source( source, osmosdr::ALL_MBOARDS );
-  }
+  return _manager->set_time_source( source, mboard );
 }
 
 std::string source_impl::get_time_source(const size_t mboard)
 {
-  return _devs.at(mboard)->get_time_source( mboard );
+  return _manager->get_time_source( mboard );
 }
 
 std::vector<std::string> source_impl::get_time_sources(const size_t mboard)
 {
-  return _devs.at(mboard)->get_time_sources( mboard );
+  return _manager->get_time_sources( mboard );
 }
 
 void source_impl::set_clock_source(const std::string &source, const size_t mboard)
 {
-  if (mboard != osmosdr::ALL_MBOARDS){
-      _devs.at(mboard)->set_clock_source( source );
-      return;
-  }
-
-  for (size_t m = 0; m < _devs.size(); m++){ /* propagate ALL_MBOARDS */
-      _devs.at(m)->set_clock_source( source, osmosdr::ALL_MBOARDS );
-  }
+  return _manager->set_clock_source( source, mboard );
 }
 
 std::string source_impl::get_clock_source(const size_t mboard)
 {
-  return _devs.at(mboard)->get_clock_source( mboard );
+  return _manager->get_clock_source( mboard );
 }
 
 std::vector<std::string> source_impl::get_clock_sources(const size_t mboard)
 {
-  return _devs.at(mboard)->get_clock_sources( mboard );
+  return _manager->get_clock_sources( mboard );
 }
 
 double source_impl::get_clock_rate(size_t mboard)
 {
-  return _devs.at(mboard)->get_clock_rate( mboard );
+  return _manager->get_clock_rate( mboard );
 }
 
 void source_impl::set_clock_rate(double rate, size_t mboard)
 {
-  if (mboard != osmosdr::ALL_MBOARDS){
-      _devs.at(mboard)->set_clock_rate( rate );
-      return;
-  }
-
-  for (size_t m = 0; m < _devs.size(); m++){ /* propagate ALL_MBOARDS */
-      _devs.at(m)->set_clock_rate( rate, osmosdr::ALL_MBOARDS );
-  }
+  return _manager->set_clock_rate( rate, mboard );
 }
 
 osmosdr::time_spec_t source_impl::get_time_now(size_t mboard)
 {
-  return _devs.at(mboard)->get_time_now( mboard );
+  return _manager->get_time_now( mboard );
 }
 
 osmosdr::time_spec_t source_impl::get_time_last_pps(size_t mboard)
 {
-  return _devs.at(mboard)->get_time_last_pps( mboard );
+  return _manager->get_time_last_pps( mboard );
 }
 
 void source_impl::set_time_now(const osmosdr::time_spec_t &time_spec, size_t mboard)
 {
-  if (mboard != osmosdr::ALL_MBOARDS){
-      _devs.at(mboard)->set_time_now( time_spec );
-      return;
-  }
-
-  for (size_t m = 0; m < _devs.size(); m++){ /* propagate ALL_MBOARDS */
-      _devs.at(m)->set_time_now( time_spec, osmosdr::ALL_MBOARDS );
-  }
+  return _manager->set_time_now( time_spec, mboard );
 }
 
 void source_impl::set_time_next_pps(const osmosdr::time_spec_t &time_spec)
 {
-  BOOST_FOREACH( source_iface *dev, _devs )
-  {
-    dev->set_time_next_pps( time_spec );
-  }
+  return _manager->set_time_next_pps( time_spec );
 }
 
 void source_impl::set_time_unknown_pps(const osmosdr::time_spec_t &time_spec)
 {
-  BOOST_FOREACH( source_iface *dev, _devs )
-  {
-    dev->set_time_unknown_pps( time_spec );
-  }
+  return _manager->set_time_unknown_pps( time_spec );
 }
diff --git a/lib/source_impl.h b/lib/source_impl.h
index 4b65125..238bc6c 100644
--- a/lib/source_impl.h
+++ b/lib/source_impl.h
@@ -27,7 +27,7 @@
 #include <gnuradio/iqbalance/fix_cc.h>
 #endif
 
-#include <source_iface.h>
+#include "dev_manager.h"
 
 #include <map>
 
@@ -92,23 +92,7 @@ public:
   void set_time_unknown_pps(const ::osmosdr::time_spec_t &time_spec);
 
 private:
-  std::vector< source_iface * > _devs;
-
-  /* cache to prevent multiple device calls with the same value coming from grc */
-  double _sample_rate;
-  std::map< size_t, double > _center_freq;
-  std::map< size_t, double > _freq_corr;
-  std::map< size_t, bool > _gain_mode;
-  std::map< size_t, double > _gain;
-  std::map< size_t, double > _if_gain;
-  std::map< size_t, double > _bb_gain;
-  std::map< size_t, std::string > _antenna;
-#ifdef HAVE_IQBALANCE
-  std::vector< gr::iqbalance::fix_cc * > _iq_fix;
-  std::vector< gr::iqbalance::optimize_c * > _iq_opt;
-  std::map< size_t, std::pair<float, float> > _vals;
-#endif
-  std::map< size_t, double > _bandwidth;
+  dev_manager_sptr _manager;
 };
 
 #endif /* INCLUDED_OSMOSDR_SOURCE_IMPL_H */
diff --git a/lib/uhd/uhd_sink_c.cc b/lib/uhd/uhd_sink_c.cc
index a154556..fdac2a6 100644
--- a/lib/uhd/uhd_sink_c.cc
+++ b/lib/uhd/uhd_sink_c.cc
@@ -24,6 +24,8 @@
 
 //#include <uhd/property_tree.hpp>
 
+#include <osmosdr/messages.h>
+
 #include "arg_helpers.h"
 
 #include "uhd_sink_c.h"
@@ -124,6 +126,9 @@ uhd_sink_c::uhd_sink_c(const std::string &args) :
 #endif
   for ( size_t i = 0; i < nchan; i++ )
     connect( self(), i, _snk, i );
+  
+  message_port_register_hier_in( osmosdr::CMD_PORT );
+  msg_connect( self(), osmosdr::CMD_PORT, _snk, osmosdr::CMD_PORT );
 }
 
 uhd_sink_c::~uhd_sink_c()
diff --git a/lib/uhd/uhd_source_c.cc b/lib/uhd/uhd_source_c.cc
index fc13017..98fd5f1 100644
--- a/lib/uhd/uhd_source_c.cc
+++ b/lib/uhd/uhd_source_c.cc
@@ -24,6 +24,8 @@
 
 //#include <uhd/property_tree.hpp>
 
+#include <osmosdr/messages.h>
+
 #include "arg_helpers.h"
 
 #include "uhd_source_c.h"
@@ -125,6 +127,9 @@ uhd_source_c::uhd_source_c(const std::string &args) :
 #endif
   for ( size_t i = 0; i < nchan; i++ )
     connect( _src, i, self(), i );
+  
+  message_port_register_hier_in( osmosdr::CMD_PORT );
+  msg_connect( self(), osmosdr::CMD_PORT, _src, osmosdr::CMD_PORT );
 }
 
 uhd_source_c::~uhd_source_c()
-- 
2.15.1

